Distribution:	CCux
Packager:  	Karsten Brockmann <arcam@ccux-linux.de>

Summary:   	A collection of basic system utilities.
Name:      	util-linux-ng
Version:   	2.13.1.1
Release:   	1
License: 	GNU/GPL
URL:		http://userweb.kernel.org/~kzak/util-linux-ng/
Group:     	System/Base          
Source0: 	ftp://ftp.kernel.org/pub/linux/utils/%{name}/v2.13/%{name}-%{version}.tar.bz2
Source1: 	util-linux-ng-login.pamd
Source2: 	util-linux-ng-remote.pamd
Source3: 	util-linux-ng-chsh-chfn.pamd
Source4: 	util-linux-ng-60-raw.rules
Source8: 	nologin.c
Source9: 	nologin.8
Source10: 	http://download.sourceforge.net/floppyutil/floppy-%{floppyver}.tar.bz2

# 91174 - Patch to enabled remote service for login/pam
Patch0: util-linux-ng-2.13-login-pamstart.patch
# RHEL/Fedora specific mount options
Patch1: util-linux-ng-2.13-mount-managed.patch
Patch2: util-linux-ng-2.13-mount-pamconsole.patch
# add note about ATAPI IDE floppy to fdformat.8
Patch3: util-linux-ng-2.13-fdformat-man-ide.patch
# 169628 - /usr/bin/floppy doesn't work with /dev/fd0
Patch4: util-linux-ng-2.13-floppy-generic.patch
# 151635 - makeing /var/log/lastlog
Patch5: util-linux-ng-2.13-login-lastlog.patch
# 199745 - Non-existant simpleinit(8) mentioned in ctrlaltdel(8)
Patch6: util-linux-ng-2.13-ctrlaltdel-man.patch
# 218915 - fdisk -b 4K (move to upstream?)
Patch7: util-linux-ng-2.13-fdisk-b-4096.patch
# 231192 - ipcs is not printing correct values on pLinux
Patch8: util-linux-ng-2.13-ipcs-32bit.patch
# 174111 - mount allows loopback devices to be mounted more than once to the
#       same mount point (move to upstream?)
Patch9: util-linux-ng-2.13-mount-twiceloop.patch
# 165863 - swsusp swaps should be reinitialized
Patch10: util-linux-ng-2.13-swapon-swsuspend.patch
# add a missing header
Patch11: util-linux-ng-2.13-floppy-locale.patch
# remove partitions
Patch12: util-linux-ng-2.13-blockdev-rmpart.patch
# 439984 - backport mkswap -U
Patch13: util-linux-ng-2.13-mkswap-uuid.patch
# 443823 - ionice.1 doesn't to reflect idle class changes in 2.6.25
Patch14: util-linux-ng-2.13-ionice-man-idle.patch

Obsoletes:	util-linux < 2.13
Provides:	util-linux = %{version}
BuildRoot: 	%{_tmppath}/%{name}-buildroot
Prereq(post,preun): /sbin/install-info
BuildArch:	i686

%define floppyver 0.16

%description
The util-linux-ng is a fork of the original util-linux project. 
The goal of the util-linux-ng is a transparent and reliable development that follows the Linux kernel and Linux distributions. 
util-linux contains a large variety of low-level system utilities that are necessary for a Linux system to function. Among
others, Util-linux contains the fdisk configuration tool and the login program.

%post
/sbin/install-info %{_infodir}/ipc.info %{_infodir}/dir
# only for minimal buildroots without /var/log
[ -d /var/log ] || /bin/mkdir -p /var/log
/bin/touch /var/log/lastlog
/bin/chown root:root /var/log/lastlog
/bin/chmod 0644 /var/log/lastlog

%preun
if [ "$1" = 0 ]; then
        /sbin/install-info --del %{_infodir}/ipc.info %{_infodir}/dir
fi
exit 0

%prep
%setup -q -a 10
cp %{SOURCE8} %{SOURCE9} .

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1

%build
export CFLAGS="-D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 $RPM_OPT_FLAGS"
export SUID_CFLAGS="-fpie"
export SUID_LDFLAGS="-pie"
%configure \
        --bindir=/bin \
        --sbindir=/sbin \
        --disable-wall \
        --enable-partx \
        --enable-login-utils \
        --enable-kill \
        --enable-write \
        --enable-arch \
        --enable-raw \
        --with-fsprobe=blkid \
        --disable-makeinstall-chown

# build util-linux-ng
make 

# build floppy stuff
pushd floppy-%{floppyver}
%configure --disable-gtk2
make 
popd

# build nologin
gcc $CFLAGS -o nologin nologin.c

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/{bin,sbin}
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_infodir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man{1,6,8,5}
mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/{pam.d,security/console.apps}
mkdir -p ${RPM_BUILD_ROOT}/var/log
touch ${RPM_BUILD_ROOT}/var/log/lastlog
chmod 0644 ${RPM_BUILD_ROOT}/var/log/lastlog

# install util-linux-ng
make install DESTDIR=${RPM_BUILD_ROOT}

# install floppy stuff
pushd floppy-%{floppyver}
make install DESTDIR=${RPM_BUILD_ROOT}
popd

# install nologin
install -m 755 nologin ${RPM_BUILD_ROOT}/sbin
install -m 644 nologin.8 ${RPM_BUILD_ROOT}%{_mandir}/man8

# raw integration
echo '.so man8/raw.8' > $RPM_BUILD_ROOT%{_mandir}/man8/rawdevices.8
{
        # see RH bugzilla #216664
        mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/udev/rules.d
        pushd ${RPM_BUILD_ROOT}%{_sysconfdir}/udev/rules.d
        install -m 644 %{SOURCE4} ./60-raw.rules
        popd
}

# PAM settings
{
        pushd ${RPM_BUILD_ROOT}%{_sysconfdir}/pam.d
        install -m 644 %{SOURCE1} ./login
        install -m 644 %{SOURCE2} ./remote
        install -m 644 %{SOURCE3} ./chsh
        install -m 644 %{SOURCE3} ./chfn
        popd
}

ln -sf ../../sbin/hwclock ${RPM_BUILD_ROOT}/usr/sbin/hwclock
ln -sf hwclock ${RPM_BUILD_ROOT}/sbin/clock


# Final cleanup

# deprecated commands
for I in /sbin/fsck.minix /sbin/mkfs.{bfs,minix} /sbin/sln \
        /usr/bin/chkdupexe %{_bindir}/line %{_bindir}/pg %{_bindir}/newgrp \
        /sbin/shutdown %{_bindir}/scriptreplay /usr/sbin/vipw /usr/sbin/vigr; do
        rm -f $RPM_BUILD_ROOT$I
done

# deprecated man pages
for I in man1/chkdupexe.1 man1/line.1 man1/pg.1 man1/newgrp.1 \
        man8/fsck.minix.8 man8/mkfs.minix.8 man8/mkfs.bfs.8 man1/scriptreplay.1 \
        man8/vipw.8 man8/vigr; do
        rm -rf $RPM_BUILD_ROOT%{_mandir}/${I}*
done

# deprecated docs
for I in text-utils/README.pg misc-utils/README.reset floppy-%{floppyver}/README.html; do
        rm -rf $I
done

# rename docs
mv floppy-%{floppyver}/README floppy-%{floppyver}/README.floppy

# we install getopt/getopt-*.{bash,tcsh} as doc files
chmod 644 getopt/getopt-*.{bash,tcsh}
rm -f ${RPM_BUILD_ROOT}%{_datadir}/getopt/*
rmdir ${RPM_BUILD_ROOT}%{_datadir}/getopt

ln -sf ../../bin/kill $RPM_BUILD_ROOT%{_bindir}/kill

# /usr/sbin -> /sbin
for I in addpart delpart partx; do
        if [ -e $RPM_BUILD_ROOT/usr/sbin/$I ]; then
                mv $RPM_BUILD_ROOT/usr/sbin/$I $RPM_BUILD_ROOT/sbin/$I
        fi
done

# /usr/bin -> /bin
for I in taskset; do
        if [ -e $RPM_BUILD_ROOT/usr/bin/$I ]; then
                mv $RPM_BUILD_ROOT/usr/bin/$I $RPM_BUILD_ROOT/bin/$I
        fi
done

# /sbin -> /bin
for I in raw; do
        if [ -e $RPM_BUILD_ROOT/sbin/$I ]; then
                mv $RPM_BUILD_ROOT/sbin/$I $RPM_BUILD_ROOT/bin/$I
        fi
done

# omit info/dir file
rm -f ${RPM_BUILD_ROOT}%{_infodir}/dir

#strip build
find %{buildroot} -type f \
-exec /usr/bin/strip --strip-debug '{}' ';'


# the binary tool files get explicitly listed here to
# keep track of them in further updates !
%files
%defattr(-,root,root)
/bin/arch
/bin/dmesg
%exclude /bin/kill
%exclude /bin/login
/bin/more
/bin/mount
/bin/raw
/bin/taskset
/bin/umount
/sbin/addpart
/sbin/agetty
/sbin/blockdev
/sbin/cfdisk
/sbin/clock
/sbin/ctrlaltdel
/sbin/delpart
/sbin/fdisk
/sbin/fsck.cramfs
/sbin/hwclock
/sbin/losetup
/sbin/mkfs
/sbin/mkfs.cramfs
/sbin/mkswap
%exclude /sbin/nologin
/sbin/partx
/sbin/pivot_root
/sbin/sfdisk
/sbin/swapoff
/sbin/swapon
/usr/bin/cal
%exclude /usr/bin/chfn
/usr/bin/chrt
%exclude /usr/bin/chsh
/usr/bin/col
/usr/bin/colcrt
/usr/bin/colrm
/usr/bin/column
/usr/bin/cytune
/usr/bin/ddate
/usr/bin/fdformat
/usr/bin/flock
/usr/bin/floppy
/usr/bin/floppygtk
/usr/bin/getopt
/usr/bin/hexdump
/usr/bin/i386
/usr/bin/ionice
/usr/bin/ipcrm
/usr/bin/ipcs
/usr/bin/isosize
%exclude /usr/bin/kill
/usr/bin/linux32
/usr/bin/linux64
/usr/bin/logger
/usr/bin/look
/usr/bin/mcookie
/usr/bin/namei
/usr/bin/rename
/usr/bin/renice
/usr/bin/rev
/usr/bin/script
/usr/bin/setarch
/usr/bin/setsid
/usr/bin/setterm
/usr/bin/tailf
/usr/bin/ul
/usr/bin/whereis
/usr/bin/write
/usr/sbin/hwclock
/usr/sbin/readprofile
/usr/sbin/rtcwake
/usr/sbin/tunelp
%_sysconfdir
%exclude %_sysconfdir/pam.d/login
%_datadir/locale
%_mandir
%exclude %_mandir/man1/chfn.1.gz
%exclude %_mandir/man1/chsh.1.gz
%exclude %_mandir/man1/login.1.gz
%exclude %_mandir/man8/nologin.8.gz
%exclude %_mandir/man1/kill.1.gz
%_infodir/ipc.info.gz
/var/log/lastlog

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Sun May 04 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.13.1.1-1
- initial release
